[retour au README.md](../../../README.md)  
[Retour aux Documents](../../README_DOCUMENTS.md)  
[Retour au diagramme de classes](../README_DIAGRAMMES.md)  

pour gerer l'accès aux données, nous avons cette structure la :
couche d'accès aux données
```plantuml
abstract class IGenericRepository {
    + getItemById(int id) : object
    + getNbItems() : int
    + getItems(int index, int count, string orderingPropertyName, bool descending) : array
    + getItemsByName(string substring, int index, int count, string orderingPropertyName, bool descending) : array
    + getItemByName(string substring, int index, int count, string orderingPropertyName, bool descending) : object
    + updateItem(oldItem, newItem) : void
    + addItem(item) : void
    + deleteItem(item) : bool
}
abstract class IUserRepository extends IGenericRepository {
}
interface INotificationRepository extends IGenericRepository {
}
interface IRelationshipRequestRepository extends IGenericRepository {
}
interface ITrainingRepository extends IGenericRepository {
}
class NotificationRepository implements INotificationRepository {
    - notifications : array
    + getItemById(int id) : object
    + getNbItems() : int
    + getItems(int index, int count, string orderingPropertyName, bool descending) : array
    + getItemsByName(string substring, int index, int count, string orderingPropertyName, bool descending) : array
    + getItemByName(string substring, int index, int count, string orderingPropertyName, bool descending) : object
    + updateItem(oldItem, newItem) : void
    + addItem(item) : void
    + deleteItem(item) : bool
}
class RelationshipRequestRepository implements IRelationshipRequestRepository {
    - requests : array
    + getItemById(int id) : object
    + getNbItems() : int
    + getItems(int index, int count, string orderingPropertyName, bool descending) : array
    + getItemsByName(string substring, int index, int count, string orderingPropertyName, bool descending) : array
    + getItemByName(string substring, int index, int count, string orderingPropertyName, bool descending) : object
    + updateItem(oldItem, newItem) : void
    + addItem(item) : void
    + deleteItem(item) : bool
}
class TrainingRepository implements ITrainingRepository {
    - trainings : array
    + getItemById(int id) : object
    + getNbItems() : int
    + getItems(int index, int count, string orderingPropertyName, bool descending) : array
    + getItemsByDate(date, int index, int count, string orderingPropertyName, bool descending) : array
    + updateItem(oldItem, newItem) : void
    + addItem(item) : void
    + deleteItem(item) : bool
}
class UserRepository implements IUserRepository {
    - users : array
    + getItemById(int id) : object
    + getNbItems() : int
    + getItems(int index, int count, string orderingPropertyName, bool descending) : array
    + getItemsByName(string substring, int index, int count, string orderingPropertyName, bool descending) : array
    + getItemByName(string substring, int index, int count, string orderingPropertyName, bool descending) : object
    + updateItem(oldItem, newItem) : void
    + addItem(item) : void
    + deleteItem(item) : bool
}
```